local HM = {
	Event = {},
	data = {
		enabled = true,
		playerID = "",
		update = true,
	},
	 
}

function HM:On()
	HM.data.enabled = true
	table.insert(Event.Combat.Death, 		{HM.Event.Death, 		"HitMan", "Handle Death"})
	table.insert(Event.System.Update.Begin, {fade, "HitMan", "fade"})
	
end

function HM:Off()
	HM.data.enabled = false
	HM:UnregisterEvent(Event.Combat.Death, 		HM.Event.Death)
	end


function HM:Toggle()
	HM.data.enabled = not HM.data.enabled
	if HM.data.enabled then
		HM:On()
	else
		HM:Off()
	end
end

function HM:UnregisterEvent(event, func)
	for i, value in ipairs(event) do
		if value[1] == func then
			table.remove(event, i)
		end
	end
end

function HM.Event.LoadEnd(identifier)
	if identifier == "HitMan" then
		HM.data.playerID = Inspect.Unit.Lookup("player")
		
		HM:On()
		
		print("HitMan loaded. /HM")
	end
end


function HM.Event.Death(info)
if Inspect.Unit.Detail(HM.data.playerID).pvp then
if info.caster == HM.data.playerID and info.target ~= HM.data.playerID then


showKill(info.target)	
end

if info.caster ~= HM.data.playerID and info.target == HM.data.playerID then

showDeath(info.caster)

end

end
end



function showDeath(x)

print("You died")

end




function HM.Event.SlashHandler(params)
	if params == "show" then
		HM:On()
	elseif params == "hide" then
		HM:Off()
	else
		HM:Toggle()
	end
end


-- start frames
local main = UI.CreateContext("UI")
local kills = UI.CreateFrame("Text","kills",main)


kills:SetPoint("CENTER",UIParent,"CENTER",0,-50)
	
	
	-- set text colors
	kills:SetFont("HitMan", "Alpaca54.ttf")
	kills:SetFontColor(0,155,0,1)
	kills:SetFontSize(35)
	
	--set layers and vis
	kills:SetLayer(2)
	kills:SetVisible(true)

	
--end frames


local lastCall = Inspect.Time.Real()
function showKill(unit)
victim = Inspect.Unit.Detail(unit)
kills:SetText("you killed "..string.lower(tostring(victim.name)))
kills:SetAlpha(1)
end

function fade()
local now = Inspect.Time.Real()
	if (now<lastCall+1) then 
		return
	end
if (kills:GetAlpha() > 0) then
kills:SetAlpha(kills:GetAlpha()-.1)
end
lastCall = now
end

table.insert(Event.Addon.Load.End, 				{HM.Event.LoadEnd, 			"HitMan", "Init"})
table.insert(Command.Slash.Register("HM"), 		{HM.Event.SlashHandler, 	"HitMan", "Slash"})